Loading...
Searching...
No Matches
casacore::LCHDF5Mask Class Reference
lattices package (libcasa_lattices) » LRegions_module » LRegions_module_internal_classes

More...

`#include <LCHDF5Mask.h>`

## Public Member Functions

| LCHDF5Mask ()
| LCHDF5Mask (const TiledShape &latticeShape, const std::shared_ptr< HDF5File > &file, const String &maskName)
| Construct an HDF5Mask object for (part of) a lattice.
| LCHDF5Mask (const TiledShape &maskShape, const LCBox &box, const std::shared_ptr< HDF5File > &file, const String &maskName)
| LCHDF5Mask (HDF5Lattice< Bool > &mask, const LCBox &box)
| LCHDF5Mask (const LCHDF5Mask &other)
| Copy constructor (copy semantics).
virtual | ~LCHDF5Mask ()
| Destructor.
LCHDF5Mask & | operator= (const LCHDF5Mask &other)
| Assignment (reference semantics).
virtual Bool | operator== (const LCRegion &other) const
| Comparison.
virtual LCRegion * | cloneRegion () const
| Make a copy of the derived object.
virtual LatticeIterInterface< Bool > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| This function is used by the LatticeIterator class to generate an iterator of the correct type for this Lattice.
virtual uInt | advisedMaxPixels () const
| Returns the maximum recommended number of pixels for a cursor.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Help the user pick a cursor for most efficient access.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual String | type () const
| Region type.
virtual TableRecord | toRecord (const String &tableName) const
| Convert the (derived) object to a record.
virtual Bool | isWritable () const
| An LCHDF5Mask is writable if the underlying HDF5Lattice is.
Public Member Functions inherited from casacore::LCRegionSingle
| LCRegionSingle ()
| LCRegionSingle (const IPosition &latticeShape)
| Construct with the lattice shape only.
| LCRegionSingle (const LCRegionSingle &other)
| Copy constructor (copy semantics).
virtual | ~LCRegionSingle ()
virtual Bool | hasMask () const
| Does the region have a mask?
const Array< Bool > | maskArray () const
| Get the mask (as an array).
Bool | masksEqual (const LCRegion &other) const
| Is the mask of this region the same as the mask of the other.
virtual void | set (const Bool &value)
| The following "put" functions are described in detail in class Lattice.
virtual void | apply (Bool(*function)(Bool))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (Bool(*function)(const Bool &))
virtual void | apply (const Functional< Bool, Bool > &function)
virtual void | putAt (const Bool &value, const IPosition &where)
| Put the value of a single element.
virtual void | copyData (const Lattice< Bool > &from)
| Copy the data from the given lattice to this one.
Public Member Functions inherited from casacore::LCRegion
| LCRegion ()
| LCRegion (const IPosition &latticeShape)
| Construct with the lattice shape only.
| LCRegion (const LCRegion &other)
| Copy constructor (copy semantics).
virtual | ~LCRegion ()
Bool | operator!= (const LCRegion &other) const
| Non-equality.
virtual Lattice< Bool > * | clone () const
| Make a copy of the derived object.
virtual void | handleDelete ()
| Handle deletion of the region by deleting possible tables.
virtual void | handleRename (const String &newName, Bool overwrite)
| Handle renaming the region by renaming possible tables.
const String & | comment () const
| Get or set the comment.
void | setComment (const String &comment)
LCRegion * | translate (const IPosition &translateVector) const
| Construct another LCRegion (for e.g.
LCRegion * | translate (const IPosition &translateVector, const IPosition &newLatticeShape) const
LCRegion * | translate (const Vector< Float > &translateVector) const
LCRegion * | translate (const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
const IPosition & | latticeShape () const
| Give the full lattice shape.
const Slicer & | boundingBox () const
| Give the bounding box.
Slicer | expand (const Slicer &slicer) const
| Expand a slicer or position in the region to the full lattice.
IPosition | expand (const IPosition &index) const
virtual uInt | ndim () const
| Return the dimensionality of the region.
virtual IPosition | shape () const
| Return the shape of the region (i.e.
Public Member Functions inherited from casacore::Lattice< Bool >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
Bool | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual Bool | getAt (const IPosition &where) const
Bool | get (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | put (const Array< Bool > &sourceBuffer)
void | operator+= (const Lattice< Bool > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< Bool > &other)
void | operator*= (const Lattice< Bool > &other)
void | operator/= (const Lattice< Bool > &other)
virtual void | copyDataTo (Lattice< Bool > &to) const
| Copy the data from this lattice to the given lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| It is strongly recommended to use class LatticeLocker to handle lattice locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
virtual String | name (Bool stripPath=False) const
| Return the name of the current Lattice object.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual Bool | ok () const
| Check class internals - used for debugging.
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Static Public Member Functions

static String | className ()
| Get the class name (to store in the record).
static LCHDF5Mask * | fromRecord (const TableRecord &, const String &tablename)
| Convert correct object from a record.
Static Public Member Functions inherited from casacore::LCRegion
static LCRegion * | fromRecord (const TableRecord &, const String &tableName)
| Convert correct object from a record.

## Protected Member Functions

virtual LCRegion * | doTranslate (const Vector< Float > &translateVector, const IPosition &newLatticeShape) const
| Construct another LCHDF5Mask (for e.g.
Protected Member Functions inherited from casacore::LCRegionSingle
LCRegionSingle & | operator= (const LCRegionSingle &other)
| Assignment (copy semantics) is only useful for derived classes.
void | setMaskPtr (Lattice< Bool > &mask)
| Set the pointer to the mask in the derived class.
virtual Bool | doGetSlice (Array< Bool > &buffer, const Slicer &section)
| Do the actual getting of the mask.
virtual void | doPutSlice (const Array< Bool > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Do the actual putting of the mask.
Protected Member Functions inherited from casacore::LCRegion
LCRegion & | operator= (const LCRegion &other)
| Assignment (copy semantics) is only useful for derived classes.
void | setBoundingBox (const Slicer &boundingBox)
| Sometimes it is inconvenient for a derived class to set the bounding box in the constructor.
void | setShapeAndBoundingBox (const IPosition &latticeShape, const Slicer &boundingBox)
void | defineRecordFields (RecordInterface &record, const String &className) const
| Define the type and class name in the record.
Protected Member Functions inherited from casacore::Lattice< Bool >
void | handleMathTo (Lattice< Bool > &, int) const
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< Bool > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
Lattice< Bool > & | operator= (const Lattice< Bool > &)
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Private Member Functions

| LCHDF5Mask (HDF5Lattice< Bool > &mask, const IPosition &blc, const IPosition &latticeShape)
| Create the object from a record (for an existing mask).

## Private Attributes

LCBox | itsBox
HDF5Lattice< Bool > | itsMask

## Detailed Description

Class to define a rectangular mask as a region

### Intended use:

Internal

### Prerequisite

- LCRegionSingle

### Synopsis

The LCHDF5Mask class is a specialization of class LCRegionSingle. It holds a mask for an HDF5Image in an HDF5Lattice<Bool> object.

Definition at line 55 of file LCHDF5Mask.h.

## Constructor & Destructor Documentation

## LCHDF5Mask() [1/6]

casacore::LCHDF5Mask::LCHDF5Mask | ( |  | ) |

Referenced by fromRecord(), LCHDF5Mask(), and operator=().

## LCHDF5Mask() [2/6]

casacore::LCHDF5Mask::LCHDF5Mask | ( | const TiledShape & | latticeShape,
|  | const std::shared_ptr< HDF5File > & | file,
|  | const String & | maskName )

Construct an HDF5Mask object for (part of) a lattice.

It is put in group Masks of the HDF5 file. The group is created if not existing yet. The box defines the position of the mask. The default mask shape is the lattice shape.

References casacore::LCRegion::latticeShape().

## LCHDF5Mask() [3/6]

casacore::LCHDF5Mask::LCHDF5Mask | ( | const TiledShape & | maskShape,
|  | const LCBox & | box,
|  | const std::shared_ptr< HDF5File > & | file,
|  | const String & | maskName )

## LCHDF5Mask() [4/6]

casacore::LCHDF5Mask::LCHDF5Mask | ( | HDF5Lattice< Bool > & | mask,
|  | const LCBox & | box )

References casacore::mask().

## LCHDF5Mask() [5/6]

casacore::LCHDF5Mask::LCHDF5Mask | ( | const LCHDF5Mask & | other | ) |

Copy constructor (copy semantics).

References LCHDF5Mask().

## ~LCHDF5Mask()

virtual casacore::LCHDF5Mask::~LCHDF5Mask | ( |  | ) |

virtual

Destructor.

## LCHDF5Mask() [6/6]

casacore::LCHDF5Mask::LCHDF5Mask | ( | HDF5Lattice< Bool > & | mask,
|  | const IPosition & | blc,
|  | const IPosition & | latticeShape )

private

Create the object from a record (for an existing mask).

References casacore::LCRegion::latticeShape(), and casacore::mask().

## Member Function Documentation

## advisedMaxPixels()

virtual uInt casacore::LCHDF5Mask::advisedMaxPixels | ( |  | ) | const

virtual

Returns the maximum recommended number of pixels for a cursor.

This is the number of pixels in a tile.

Reimplemented from casacore::Lattice< Bool >.

## className()

String casacore::LCHDF5Mask::className | ( |  | ) |

static

Get the class name (to store in the record).

## cloneRegion()

virtual LCRegion * casacore::LCHDF5Mask::cloneRegion | ( |  | ) | const

virtual

Make a copy of the derived object.

Implements casacore::LCRegion.

## doNiceCursorShape()

virtual IPosition casacore::LCHDF5Mask::doNiceCursorShape | ( | uInt | maxPixels | ) | const

virtual

Help the user pick a cursor for most efficient access.

Reimplemented from casacore::LCRegionSingle.

## doTranslate()

virtual LCRegion * casacore::LCHDF5Mask::doTranslate | ( | const Vector< Float > & | translateVector,
|  | const IPosition & | newLatticeShape ) const

protected virtual

Construct another LCHDF5Mask (for e.g.

another lattice) by moving this one. It recalculates the bounding mask. A positive translation value indicates "to right".

Implements casacore::LCRegion.

## flush()

virtual void casacore::LCHDF5Mask::flush | ( |  | ) |

virtual

Flush the data (but do not unlock).

Reimplemented from casacore::LatticeBase.

## fromRecord()

LCHDF5Mask * casacore::LCHDF5Mask::fromRecord | ( | const TableRecord & | ,
|  | const String & | tablename )

static

Convert correct object from a record.

References LCHDF5Mask().

## isWritable()

virtual Bool casacore::LCHDF5Mask::isWritable | ( |  | ) | const

virtual

An LCHDF5Mask is writable if the underlying HDF5Lattice is.

Reimplemented from casacore::LCRegion.

## makeIter()

virtual LatticeIterInterface< Bool > * casacore::LCHDF5Mask::makeIter | ( | const LatticeNavigator & | navigator,
|  | Bool | useRef ) const

virtual

This function is used by the LatticeIterator class to generate an iterator of the correct type for this Lattice.

Not recommended for general use.

Reimplemented from casacore::LCRegionSingle.

## operator=()

LCHDF5Mask & casacore::LCHDF5Mask::operator= | ( | const LCHDF5Mask & | other | ) |

Assignment (reference semantics).

References LCHDF5Mask().

## operator==()

virtual Bool casacore::LCHDF5Mask::operator== | ( | const LCRegion & | other | ) | const

virtual

Comparison.

Reimplemented from casacore::LCRegion.

## toRecord()

virtual TableRecord casacore::LCHDF5Mask::toRecord | ( | const String & | tableName | ) | const

virtual

Convert the (derived) object to a record.

Implements casacore::LCRegion.

## type()

virtual String casacore::LCHDF5Mask::type | ( |  | ) | const

virtual

Region type.

Returns class name.

Implements casacore::LCRegion.

## Member Data Documentation

## itsBox

LCBox casacore::LCHDF5Mask::itsBox

private

Definition at line 135 of file LCHDF5Mask.h.

## itsMask

HDF5Lattice<Bool> casacore::LCHDF5Mask::itsMask

private

Definition at line 136 of file LCHDF5Mask.h.

The documentation for this class was generated from the following file:

- lattices/LRegions/LCHDF5Mask.h